# Machine Learning Fundamentals
As machine learning algorithms become popular, new tools that optimize these algorithms are also being developed. Machine Learning Fundamentals explains the scikit-learn API, which is a package created to facilitate the process of building machine learning applications. You will learn how to explain the differences between supervised and unsupervised models, and how to apply some popular algorithms to real-life datasets. 
You'll begin by learning how to use the syntax of scikit-learn. You'll study the differences between supervised and unsupervised models, as well as the importance of choosing the appropriate algorithm for each dataset. You'll apply an unsupervised clustering algorithm to real-world datasets to discover patterns and profiles, and explore the process to solve an unsupervised machine learning problem. Then, the focus of the course shifts to supervised learning algorithms. You'll learn how to implement different supervised algorithms and develop neural network structures using the scikit-learn package. You'll also learn how to perform coherent result analysis to improve the performance of the algorithm by tuning hyperparameters. 
By the end of this course, you will have the skills and confidence to start programming machine learning algorithms.


## What you will learn
* Understand the importance of data representation
* Gain insights into the differences between supervised and unsupervised models
* Explore data using the Matplotlib library
* Study popular algorithms, such as k-means, Mean-Shift, and DBSCAN
* Measure model performance through different metrics
* Implement a confusion matrix using scikit-learn
* Study popular algorithms, such as Naïve-Bayes, Decision Tree, and SVM
* Perform error analysis to improve the performance of the model
* Learn to build a comprehensive machine learning program


### Hardware requirements
For an optimal student experience, we recommend the following hardware configuration:
* **Processor**: Intel Core i5 or equivalent
* **Memory**: 4 GB RAM
* **Hard disk**: 40 GB or more
* An Internet connection



### Software requirements
You’ll also need the following software installed in advance:

* Operating System: Windows (8 or higher)
* Sublime Text (latest version), Atom IDE (latest version) or other similar text editor applications.
* Python 3 installed
* The following python libraries installed:
  * NumPy
  * SciPy
  * scikit-learn
  * Matplotlib
  * Pandas
  * pickle
  * jupyter
  * seaborn






